import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis } from "./ISortingAxis";
import { IDateTimeAxis } from "./IDateTimeAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IList$1, Type } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { SortedListView$1 } from "./SortedListView$1";
import { Series } from "./Series";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
/**
 * @hidden
 */
export declare abstract class TimeAxisBase extends CategoryAxisBase implements ISortingAxis, IDateTimeAxis {
    static $t: Type;
    constructor();
    ag(): number[];
    ft(a: number, b: ScalerParams): number;
    hd(a: any, b: string): any;
    private qo;
    private qp;
    fw(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    i$h(): void;
    q4(): void;
    protected q9(): void;
    dateTimeMemberPath: string;
    get p8(): IFastItemColumn$1<Date>;
    set p8(a: IFastItemColumn$1<Date>);
    private p7;
    private qg;
    protected get qh(): List$1<number>;
    protected set qh(a: List$1<number>);
    get i$b(): List$1<number>;
    protected q5(): void;
    i$e(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected qr(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected qq(a: Date): number;
    i$g(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected qu(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected qt(a: Date): number;
    i$d(a: number): number;
    i$c(a: number): number;
    protected qs(a: Date, b: SortedListView$1<Date>): number;
    i$f(a: number): number;
    i$i(): void;
    qd: boolean;
    private qb;
    protected get_qc(): boolean;
    protected set_qc(a: boolean): void;
    get qc(): boolean;
    set qc(a: boolean);
    kh(a: string): void;
    kk(a: any): void;
    kj(a: any): void;
    d4(): boolean;
    protected qf(): boolean;
    protected qe(): boolean;
    private qj;
    get actualMinimumValue(): Date;
    set actualMinimumValue(a: Date);
    private qi;
    hi(): any;
    get actualMaximumValue(): Date;
    set actualMaximumValue(a: Date);
    hh(): any;
    minimumValue: Date;
    maximumValue: Date;
    private q6;
    protected kf(a: any, b: string, c: any, d: any): void;
    private q3;
    protected p9(a: string): IFastItemColumn$1<Date>;
    static qa(a: string, b: CategoryAxisBase): IFastItemColumn$1<Date>;
    az(): AxisLabelPanelBase;
    protected get_bk(): AxisOrientation;
    get bk(): AxisOrientation;
    protected k4(a: boolean): void;
    protected get_dc(): boolean;
    protected startCursor(): void;
    protected resetCursor(): void;
    StartTimeCursor(): void;
    ResetTimeCursor(): void;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    ou(a: Rect, b: Rect, c: Rect): number;
    protected get_dm(): boolean;
    protected q2(a: Date, b: Date): number;
    preferredCategoryMode(a: Series): CategoryMode;
    protected hc(a: number): any;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    get i$a(): boolean;
    static $$p: string[];
}
